using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using GroupLab.Networking;

namespace CalendarData
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.ListBox listBox2;

		// database connection
		private ADODB.Connection myDB;
		// shared dictionary		
		private GroupLab.Networking.SharedDictionary sd;
		private System.Windows.Forms.DateTimePicker dateTimePicker1;
		private System.Windows.Forms.Label label1;
		// subscription for current location
		private GroupLab.Networking.Subscription sub;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				// close database connection
				myDB.Close();

				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button2 = new System.Windows.Forms.Button();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.dateTimePicker1 = new System.Windows.Forms.DateTimePicker();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(32, 104);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(264, 48);
			this.button2.TabIndex = 1;
			this.button2.Text = "Put current locations of people in Shared Dictionary";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// listBox2
			// 
			this.listBox2.Location = new System.Drawing.Point(32, 168);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(264, 212);
			this.listBox2.TabIndex = 3;
			// 
			// dateTimePicker1
			// 
			this.dateTimePicker1.Format = System.Windows.Forms.DateTimePickerFormat.Time;
			this.dateTimePicker1.Location = new System.Drawing.Point(208, 32);
			this.dateTimePicker1.Name = "dateTimePicker1";
			this.dateTimePicker1.Size = new System.Drawing.Size(88, 20);
			this.dateTimePicker1.TabIndex = 4;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(40, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(144, 24);
			this.label1.TabIndex = 5;
			this.label1.Text = "Current Time and Date";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 406);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.dateTimePicker1);
			this.Controls.Add(this.listBox2);
			this.Controls.Add(this.button2);
			this.Name = "Form1";
			this.Text = "Calendar Data -> Shared Dictionary";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			// connect to the database
			myDB = new ADODB.Connection();
			string connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + "alphabetFamilyCalendar.mdb";
			this.myDB.Open(connectionString, null, null, 0);

			// connect to the shared dictionary
			sd = new SharedDictionary();
			sd.Opened+=new EventHandler(sd_Opened);
			sd.Url = "tcp://localhost:home_space";
			sd.Open();
			sub = new Subscription();

		
			
		}

		/// <summary>
		/// Perform the specified SQL query
		/// </summary>
		/// <param name="sql">SQL query string</param>
		/// <returns>True if 1 or more rows were affected</returns>
		private bool SQL(string sql)
		{
			try
			{
				lock (this.myDB)
				{
					object recordsAffected;
					this.myDB.Execute(sql, out recordsAffected, 0);                                        
					return true;
				}
			}
			catch (Exception e)
			{
				Console.WriteLine(e);
			}

			return false;
		}

		private void sd_Opened(object sender, EventArgs e)
		{
			Console.WriteLine("Dictionary connected");
			// subscribe to the current location
			sub.BeginInit();
			sub.Dictionary = this.sd;
			sub.Pattern = "/location/?";			
			sub.Notified+=new SubscriptionEventHandler(sub_Notified);
			sub.EndInit();
		}

		private void sub_Notified(object sender, GroupLab.Networking.SubscriptionEventArgs e)
		{

			// find out which person's location changed in the shared dictionary
			string name;
			if (e.Path == "/location/anne")
				name = "Anne";
			else if (e.Path == "/location/bob")
				name = "Bob";
			else if (e.Path == "/location/catie")
				name = "Catie";
			else 
				name = "Dave";

			// add new location information to the listbox
			this.listBox2.Items.Add(name + " is at " + e.Value);
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			// find the location of each family member
			findPerson("Bob");
			findPerson("Anne");
			findPerson("Catie");
			findPerson("Dave");

		}
		private void findPerson(string name)
		{
			string location;

			// use the date picker for the current date and tiem
			string date = dateTimePicker1.Value.ToString(); //DateTime.Now.ToShortDateString();

			// grab records for the 'current time'
			ADODB.Recordset myRS = new ADODB.Recordset();						
			myRS.Open("Select * from Event where Name='" + name + "' and StartDayTime<=#" + date + "# and  EndDayTime >=#" + date + "#", myDB, ADODB.CursorTypeEnum.adOpenKeyset, ADODB.LockTypeEnum.adLockOptimistic, 0);

			if (!myRS.EOF)
				location = (string) myRS.Fields["Location"].Value;
			else
				location = "home";

			// put location and name into the shared dictionary
			this.sd.Add("/location/" + name + "/", location);			
			this.sd.Add("/location/" + name + "/name", name);			
			
		}
	}
}
